/*
 * PeRdr - PE file disassembler
 * Copyright (C) 1999-2002 Frediano Ziglio
 * -----
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * -----
 *
 * INFORMATION
 *   www: http://freddy77.tripod.com/perdr/
 *     e-mail: freddy77@angelfire.com
 *     */
#include "global.h"
#ifdef HAVE_HDRSTOP
#pragma hdrstop
#endif

#include <algorithm>
#include "apicache.h"
#include "apiexp.h"

using namespace std;

bool ApiCache::GetFullApiName(std::string& out,const char* dllName,int ordinal)
{
	// find dll
	// FIXME do a best search, dll should be ordered
	const DllFunctions *dll;
	for(dll = cachedDlls; ; )
	{
		if (stricmp(dll->name,dllName)==0)
			break;
		++dll;
		if (dll == (cachedDlls + numCachedDlls) )
			return false;
	}

	// find function
	const int *pend = dll->ords + dll->count;
	const int *p = lower_bound(dll->ords,pend,ordinal);
	if ( pend == p || *p != ordinal)
		return false;
	out = dll->names[p-dll->ords];
	return true;
}

