/*
PeRdr - PE file disassembler
Copyright (C) 1999-2002 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#include "global.h"
#ifdef HAVE_HDRSTOP
#pragma hdrstop
#endif

#include "relocationinfo.h"

void RelocationInfos::AddRelocation(const Relocation& rel,vma_t address)
{
  _PRG_ASSERT(rel.GetType() == Relocation::relNone ||
    rel.GetType() == Relocation::relRelative);
  if ( rel.GetType() != Relocation::relNone )
    relocations.insert(address);
}

void RelocationInfos::GetRelocation(Relocation& info,vma_t address,unsigned bytes) const
{
  t_relocations::const_iterator i = relocations.lower_bound(address);
  if ( i == relocations.end() )
  {
    info.SetType(Relocation::relNone);
    return;
  }

  Relocation::Type type = Relocation::relNone;
  if ( *i == address && bytes == 4 ) // !!! constants !!!
    // la rilocazione e' ok!
    type = Relocation::relRelative;
  else if ( address+bytes > *i )
    // l'indirizzo dato interseca con una rilocazione
    type = Relocation::relError;
  info.SetType(type);
}

Relocation::Type RelocationInfos::GetRelocationType(vma_t address) const
{
  // !!! memoriazzre ultimo byte per rilocazioni ?
  t_relocations::const_iterator i = relocations.lower_bound(address-3);
  if ( i == relocations.end() )
    return Relocation::relNone;
  if ( *i == address)
    return Relocation::relRelative;
  if ( (address - *i) < 4 ) // !!! constants !!!
    return Relocation::relError;
  return Relocation::relNone;
}

