/*
PeRdr - PE file disassembler
Copyright (C) 1999-2002 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#ifndef FILE_RELOCATIONINFO_H
#define FILE_RELOCATIONINFO_H

#include <set>

// contiene informazioni circa le rilocazioni di un letterale
class Relocation
{
public:
  // tipi di rilocazione
  // relError e' usata nel caso che la rilocazione non sia completa
  // (es: presi 2 byte di una rilocazione)
  typedef enum _Type { relError = -1, relNone, relRelative, relAbsolute } Type;
  Relocation(Type _type = relNone):type(_type) {};
  Type GetType() const { return type; };
  void SetType(Type _type) { type = _type; };
private:
  Type type;
};

class RelocationInfos
{
public:
  void AddRelocation(const Relocation& rel,vma_t address);
  // funzione per verificare presenza rilocazioni e settare informazioni
  // rilocazione
  // usata per motivi di performance al posto dell'altra
  void GetRelocation(Relocation& info,vma_t address,unsigned bytes) const;
  inline Relocation GetRelocation(vma_t address,unsigned bytes) const
  {
    Relocation tmp;
    GetRelocation(tmp,address,bytes);
    return tmp;
  }

  // testa se la cella di memoria indicata e' contenuta in una rilocazione
  Relocation::Type GetRelocationType(vma_t address) const;
private:
  // per ora contiene solo rilocazioni di tipo relativo
  typedef std::set<vma_t,std::less<vma_t> > t_relocations;
  t_relocations relocations;
};

#endif //FILE_RELOCATIONINFO_H
