#ifdef __WIN32__
# ifndef _WIN32
#  define _WIN32 1
# endif
#endif

#if defined(_WIN32) && !defined(__GNUC__)
// Windows 32 e 64
typedef signed   char  int8_t;
typedef unsigned char uint8_t;
typedef          short int  int16_t;
typedef unsigned short int uint16_t;
typedef          int  int32_t;
typedef unsigned int uint32_t;

// fast types
typedef signed   char   int_fast8_t;
typedef          int   int_fast16_t;
typedef          int   int_fast32_t;
typedef unsigned char  uint_fast8_t;
typedef unsigned int  uint_fast16_t;
typedef unsigned int  uint_fast32_t;

# ifdef _WIN64
// Windows 64
// - 64 bit
typedef          __int64  int64_t;
typedef unsigned __int64 uint64_t;
// - big architectured
typedef  int64_t  int3264_t;
typedef uint64_t uint3264_t;
// - void* to int types
#  ifndef intptr_t
typedef __int64 intptr_t;
#  endif
typedef unsigned __int64 uintptr_t;
# else
// Windows 32
// - 64 bit
#  ifndef __BORLANDC__
// assume microsoft
typedef          __int64  int64_t;
typedef unsigned __int64 uint64_t;
#  endif
# endif
// - big architectured
typedef          int  int3264_t;
typedef unsigned int uint3264_t;
// - void* to int types
#  ifndef intptr_t
typedef int intptr_t;
#  endif
typedef unsigned int uintptr_t;
#endif

#if defined(_WIN32) && defined(__GNUC__)
# ifndef __MINGW32__
#  include <sys/types.h>
typedef u_int32_t uint32_t;
typedef u_int8_t  uint8_t;
typedef u_int16_t uint16_t;
typedef uint16_t uint_fast16_t;
# else
#  include <stdint.h>
# endif
#endif

#ifndef _Windows
#ifndef _WIN32
// assume UNIX
#include <inttypes.h>
typedef          long  int3264_t;
typedef unsigned long uint3264_t;
#endif
#endif

// !!! mancano costanti
// !!! mancano tipi per printf

// disabilita tipi pericolosi
#define DWORD __@undefined@__
#define INT   __@undefined@__
#define UINT  __@undefined@__
#define LONG  __@undefined@__
#define ULONG __@undefined@__
//#define long  __@undefined@__

#ifndef BYTEORDER
#  if defined(_WIN32) && defined(_M_IX86)
#    define BYTEORDER 1234
#  endif
#  if defined(__GNUC__) && defined(__i386__)
#    define BYTEORDER 1234
#  endif
#endif
