#!/usr/bin/perl

%allDll = ();

sub parse($)
{
	my ($dll) = @_;
	my %apis;

	# read all exports
	open(FILE,"perdr --show-exports ../test/dlls/$dll.dll |") || die("Unable to open");
	while(<FILE>)
	{
		if ($_ =~ /^ Addr:[0-9A-F]{8} hint:([0-9]+)\([0-9A-F]+\) Name:(.+)$/)
		{	$apis{$1} = $2;
		}
	}
	close(FILE);

	# print array of orderer ordinals
	print "static const int ords_$dll\[\] = {\n\t";
	$n = 0;
	foreach $i (sort { $a <=> $b } keys(%apis))
	{
		if ($n != 0)
		{
			print ",";
			if ($n % 8 == 0)
			{ print "\n\t"; }
		}
		print "$i";
		++$n;
	}
	print "\n};\n";

	# print array of names
	print "static const char * const names_$dll\[\] = {\n\t";
	$n = 0;
	foreach $i (sort { $a <=> $b } keys(%apis))
	{
		if ($n != 0)
		{
			print ",";
			if ($n % 2 == 0)
			{ print "\n\t"; }
		}
		print "\"$apis{$i}\"";
		++$n;
	}
	print "\n};\n";
	
	$n = scalar keys %apis;
	$body = qq|\t{ "$dll", $n, ords_$dll, names_$dll }, \n|;
	$allDll{$dll} = $body;
}

print qq|/* Autogenerated by apiexport.pl, do not edit directly
 */

|;
&parse("wsock32");
&parse("odbc32");
&parse("oleaut32");

print qq|const ApiCache::DllFunctions ApiCache::cachedDlls[] = {
|;
foreach $i (sort keys %allDll)
{
	print qq|$allDll{$i}|;
}
print qq|
};
|;

$n = scalar keys %allDll;
print qq|const int ApiCache::numCachedDlls = $n;
|;
